/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2203 from the
 * contents of SHA3.xs. Do not edit this file, edit SHA3.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "SHA3.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef SvPVbyte
	#if PERL_REVISION == 5 && PERL_VERSION < 8
		#undef SvPVbyte
		#define SvPVbyte(sv, lp) \
			(sv_utf8_downgrade((sv), 0), SvPV((sv), (lp)))
	#endif
#else
	#define SvPVbyte SvPV
#endif

#ifndef dTHX
	#define pTHX_
	#define aTHX_
#endif

#ifndef PerlIO
	#define PerlIO				FILE
	#define PerlIO_read(f, buf, count)	fread(buf, 1, count, f)
#endif

#ifndef sv_derived_from
	#include "src/sdf.c"
#endif

#ifndef Newx
	#define Newx(ptr, num, type)	New(0, ptr, num, type)
	#define Newxz(ptr, num, type)	Newz(0, ptr, num, type)
#endif

#include "src/sha3.c"

static const int ix2alg[] =
	{224,224,224,256,256,256,384,384,384,512,512,512,
	 128000,128000,128000,256000,256000,256000};

#ifndef INT2PTR
#define INT2PTR(p, i) (p) (i)
#endif

#define MAX_WRITE_SIZE 16384
#define IO_BUFFER_SIZE 4096

static SHA3 *getSHA3(pTHX_ SV *self)
{
	if (!sv_isobject(self) || !sv_derived_from(self, "Digest::SHA3"))
		return(NULL);
	return INT2PTR(SHA3 *, SvIV(SvRV(self)));
}

#line 65 "SHA3.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 117 "SHA3.c"

XS(XS_Digest__SHA3_shainit); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_shainit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "s, alg");
    {
	SHA3 *	s = getSHA3(aTHX_ ST(0));
	int	alg = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = shainit(s, alg);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA3_sharewind); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_sharewind)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	SHA3 *	s = getSHA3(aTHX_ ST(0));

	sharewind(s);
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__SHA3_shawrite); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_shawrite)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "bitstr, bitcnt, s");
    {
	unsigned char *	bitstr = (unsigned char *)SvPV_nolen(ST(0));
	unsigned long	bitcnt = (unsigned long)SvUV(ST(1));
	SHA3 *	s = getSHA3(aTHX_ ST(2));
	unsigned long	RETVAL;
	dXSTARG;

	RETVAL = shawrite(bitstr, bitcnt, s);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA3_newSHA3); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_newSHA3)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "classname, alg");
    {
	char *	classname = (char *)SvPV_nolen(ST(0));
	int	alg = (int)SvIV(ST(1));
#line 79 "SHA3.xs"
	SHA3 *state;
#line 200 "SHA3.c"
	SV *	RETVAL;
#line 81 "SHA3.xs"
	Newxz(state, 1, SHA3);
	if (!shainit(state, alg)) {
		Safefree(state);
		XSRETURN_UNDEF;
	}
	RETVAL = newSV(0);
	sv_setref_pv(RETVAL, classname, (void *) state);
	SvREADONLY_on(SvRV(RETVAL));
#line 211 "SHA3.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA3_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_clone)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0);
#line 96 "SHA3.xs"
	SHA3 *state;
	SHA3 *clone;
#line 234 "SHA3.c"
	SV *	RETVAL;
#line 99 "SHA3.xs"
	if ((state = getSHA3(aTHX_ self)) == NULL)
		XSRETURN_UNDEF;
	Newx(clone, 1, SHA3);
	RETVAL = newSV(0);
	sv_setref_pv(RETVAL, sv_reftype(SvRV(self), 1), (void *) clone);
	SvREADONLY_on(SvRV(RETVAL));
	Copy(state, clone, 1, SHA3);
#line 244 "SHA3.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA3_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	SHA3 *	s = getSHA3(aTHX_ ST(0));
#line 113 "SHA3.xs"
	Safefree(s);
#line 266 "SHA3.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__SHA3_sha3_224); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_sha3_224)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 137 "SHA3.xs"
	int i;
	UCHR *data;
	STRLEN len;
	SHA3 sha3;
	char *result;
#line 289 "SHA3.c"
	SV *	RETVAL;
#line 143 "SHA3.xs"
	if (!shainit(&sha3, ix2alg[ix]))
		XSRETURN_UNDEF;
	for (i = 0; i < items; i++) {
		data = (UCHR *) (SvPVbyte(ST(i), len));
		while (len > MAX_WRITE_SIZE) {
			shawrite(data, MAX_WRITE_SIZE << 3, &sha3);
			data += MAX_WRITE_SIZE;
			len  -= MAX_WRITE_SIZE;
		}
		shawrite(data, len << 3, &sha3);
	}
	shafinish(&sha3);
	len = 0;
	if (ix % 3 == 0) {
		result = (char *) shadigest(&sha3);
		len = (STRLEN) sha3.digestlen;
	}
	else if (ix % 3 == 1)
		result = shahex(&sha3);
	else
		result = shabase64(&sha3);
	RETVAL = newSVpv(result, len);
#line 314 "SHA3.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA3_hashsize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_hashsize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0);
#line 175 "SHA3.xs"
	SHA3 *state;
#line 337 "SHA3.c"
	int	RETVAL;
	dXSTARG;
#line 177 "SHA3.xs"
	if ((state = getSHA3(aTHX_ self)) == NULL)
		XSRETURN_UNDEF;
	RETVAL = ix ? state->alg : state->digestlen << 3;
#line 344 "SHA3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA3_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0);
#line 187 "SHA3.xs"
	int i;
	UCHR *data;
	STRLEN len;
	SHA3 *state;
#line 370 "SHA3.c"
#line 192 "SHA3.xs"
	if ((state = getSHA3(aTHX_ self)) == NULL)
		XSRETURN_UNDEF;
	for (i = 1; i < items; i++) {
		data = (UCHR *) (SvPVbyte(ST(i), len));
		while (len > MAX_WRITE_SIZE) {
			shawrite(data, MAX_WRITE_SIZE << 3, state);
			data += MAX_WRITE_SIZE;
			len  -= MAX_WRITE_SIZE;
		}
		shawrite(data, len << 3, state);
	}
	XSRETURN(1);
#line 384 "SHA3.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__SHA3_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0);
#line 214 "SHA3.xs"
	STRLEN len;
	SHA3 *state;
	char *result;
#line 408 "SHA3.c"
	SV *	RETVAL;
#line 218 "SHA3.xs"
	if ((state = getSHA3(aTHX_ self)) == NULL)
		XSRETURN_UNDEF;
	shafinish(state);
	len = 0;
	if (ix == 0) {
		result = (char *) shadigest(state);
		len = (STRLEN) state->digestlen;
	}
	else if (ix == 1)
		result = shahex(state);
	else if (ix == 2)
		result = shabase64(state);
	else {
		if ((result = (char *) shasqueeze(state)) == NULL)
			XSRETURN_UNDEF;
		len = (STRLEN) state->digestlen;
	}
	RETVAL = newSVpv(result, len);
	if (ix != 3)
		sharewind(state);
#line 431 "SHA3.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA3__addfilebin); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3__addfilebin)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, f");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0);
	PerlIO *	f = IoIFP(sv_2io(ST(1)));
#line 246 "SHA3.xs"
	SHA3 *state;
	int n;
	UCHR in[IO_BUFFER_SIZE];
#line 458 "SHA3.c"
#line 250 "SHA3.xs"
	if (!f || (state = getSHA3(aTHX_ self)) == NULL)
		XSRETURN_UNDEF;
	while ((n = PerlIO_read(f, in, sizeof(in))) > 0)
		shawrite(in, (ULNG) n << 3, state);
	XSRETURN(1);
#line 465 "SHA3.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__SHA3__addfileuniv); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA3__addfileuniv)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, f");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0);
	PerlIO *	f = IoIFP(sv_2io(ST(1)));
#line 261 "SHA3.xs"
	UCHR c;
	int n;
	int cr = 0;
	UCHR *src, *dst;
	UCHR in[IO_BUFFER_SIZE+1];
	SHA3 *state;
#line 494 "SHA3.c"
#line 268 "SHA3.xs"
	if (!f || (state = getSHA3(aTHX_ self)) == NULL)
		XSRETURN_UNDEF;
	while ((n = PerlIO_read(f, in+1, IO_BUFFER_SIZE)) > 0) {
		for (dst = in, src = in + 1; n; n--) {
			c = *src++;
			if (!cr) {
				if (c == '\015')
					cr = 1;
				else
					*dst++ = c;
			}
			else {
				if (c == '\015')
					*dst++ = '\012';
				else if (c == '\012') {
					*dst++ = '\012';
					cr = 0;
				}
				else {
					*dst++ = '\012';
					*dst++ = c;
					cr = 0;
				}
			}
		}
		shawrite(in, (ULNG) (dst - in) << 3, state);
	}
	if (cr) {
		in[0] = '\012';
		shawrite(in, 1UL << 3, state);
	}
	XSRETURN(1);
#line 528 "SHA3.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Digest__SHA3); /* prototype to pass -Wmissing-prototypes */
XS(boot_Digest__SHA3)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        (void)newXSproto_portable("Digest::SHA3::shainit", XS_Digest__SHA3_shainit, file, "$$");
        (void)newXSproto_portable("Digest::SHA3::sharewind", XS_Digest__SHA3_sharewind, file, "$");
        (void)newXSproto_portable("Digest::SHA3::shawrite", XS_Digest__SHA3_shawrite, file, "$$$");
        (void)newXSproto_portable("Digest::SHA3::newSHA3", XS_Digest__SHA3_newSHA3, file, "$$");
        (void)newXSproto_portable("Digest::SHA3::clone", XS_Digest__SHA3_clone, file, "$");
        (void)newXSproto_portable("Digest::SHA3::DESTROY", XS_Digest__SHA3_DESTROY, file, "$");
        cv = newXSproto_portable("Digest::SHA3::shake128", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 12 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_512_base64", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 11 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_512_hex", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 10 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_512", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 9 ;
        cv = newXSproto_portable("Digest::SHA3::shake128_hex", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 13 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_256", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 3 ;
        cv = newXSproto_portable("Digest::SHA3::shake256_hex", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 16 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_384_hex", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 7 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_224_base64", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 2 ;
        cv = newXSproto_portable("Digest::SHA3::shake128_base64", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 14 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_256_base64", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 5 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_384_base64", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 8 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_384", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 6 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_224", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("Digest::SHA3::shake256_base64", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 17 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_256_hex", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 4 ;
        cv = newXSproto_portable("Digest::SHA3::shake256", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 15 ;
        cv = newXSproto_portable("Digest::SHA3::sha3_224_hex", XS_Digest__SHA3_sha3_224, file, ";@");
        XSANY.any_i32 = 1 ;
        cv = newXSproto_portable("Digest::SHA3::algorithm", XS_Digest__SHA3_hashsize, file, "$");
        XSANY.any_i32 = 1 ;
        cv = newXSproto_portable("Digest::SHA3::hashsize", XS_Digest__SHA3_hashsize, file, "$");
        XSANY.any_i32 = 0 ;
        (void)newXSproto_portable("Digest::SHA3::add", XS_Digest__SHA3_add, file, "$;@");
        cv = newXSproto_portable("Digest::SHA3::b64digest", XS_Digest__SHA3_digest, file, "$");
        XSANY.any_i32 = 2 ;
        cv = newXSproto_portable("Digest::SHA3::squeeze", XS_Digest__SHA3_digest, file, "$");
        XSANY.any_i32 = 3 ;
        cv = newXSproto_portable("Digest::SHA3::hexdigest", XS_Digest__SHA3_digest, file, "$");
        XSANY.any_i32 = 1 ;
        cv = newXSproto_portable("Digest::SHA3::digest", XS_Digest__SHA3_digest, file, "$");
        XSANY.any_i32 = 0 ;
        (void)newXSproto_portable("Digest::SHA3::_addfilebin", XS_Digest__SHA3__addfilebin, file, "$$");
        (void)newXSproto_portable("Digest::SHA3::_addfileuniv", XS_Digest__SHA3__addfileuniv, file, "$$");
    }
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

